(*******************************************************************)
(* Example of how the analysis can be used (see D19 Section 3.1)   *)
(*******************************************************************)

CM.make();

let
    local
        open Lysa	
    in 
    val MLP = NEW_I([([("i",1),("j",1)],NAME("K",["i","j"]))],
              PAR_I("i",1,
              PAR_X("j",1,"i",
	      PAR(
	          [BANG(
		  NEW(NAME("m",["i","j"]),
                  OUT([ENC([NAME("m",["i","j"])],
			    NAME("K",["i","j"]),
			    ("a",["i","j"]),
			    SOME(DEST([("b",["i","j"])])))],
		  NIL))),		      
		  BANG(
		  INP([],[VAR("x",["i","j"])],
		  DEC(VAR("x",["i","j"]),
		      [],
		      [VAR("y",["i","j"])],
		      NAME("K",["i","j"]),
		      ("b",["i","j"]),
		      SOME(ORIG([("a",["i","j"])])),
		  NIL)))]))))
    end

    val LP   = MLysa2Lysa.ml2lProc 3 MLP
    val LLP  = Lysa2LLysa.l2llProc LP

    val ALFP = Analysis1.analyse LLP

    val ss   = FormulaAnalyzer.init();
in
    FormulaAnalyzer.solveStd(ss,FormulaAnalyzer.inputStr(ALFP))
end