(*****************************************************************************)
(* Example of a parsing a LySa ASCII process and runing the analysis         *)
(*                                                                           *)
(*                                 Time-stamp: <10-02-2004 Mikael Buchholtz> *)
(*****************************************************************************)

CM.make();


let val filename = "protocols/example.lysa"
    val n        = 3

    val MLP      = LysaASCIIIO.parseFile filename
    val LP       = MLysa2Lysa.ml2lProc n MLP
    val LLP      = Lysa2LLysa.l2llProc LP

   (* The relation UFRHON contains pairs of (variable * name) with the     *)
   (* possible names that a variable my become bound to                    *)

    val ALFP     = (Analysis1.analyse LLP)^" &\n"^
		   "(A x. A y. A z. RHO(x,y) & C(y,z) & N(z) => UFRHON(x,z))"

    val ss       = FormulaAnalyzer.init()
in
    FormulaAnalyzer.selectSolveStd(ss,FormulaAnalyzer.inputStr(ALFP))
				  ([("UFRHON",2),("PSI",2)],false,true)
end

handle (LysaASCIIIO.parseError s) => (TextIO.print (s^"\n"))